<template>
  <!-- 新增编辑 -->
  <common-modal
    :width="700"
    :maskClosable="false"
    :visible="props.visible"
    :confirm-loading="loading"
    :forceRender="true"
    wrapClassName="project-modal"
    :title="isUpdate ? '编辑业务分类' : '新建业务分类'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
    @close="updateVisible(false)"
  >
    <ListTypeForm v-model:form="form" ref="typeFormRef" :isUpdate="isUpdate"></ListTypeForm>
  </common-modal>
</template>

<script setup name="ListTypeAddEdit">
import { ref, onMounted } from 'vue';
import ListTypeForm from './list-type-form.vue';
import { message } from 'ant-design-vue';
import { getBusinessMaxSort } from '@/utils/common/util';
import { BusinessCategoryApi } from '../../api/BusinessCategoryApi';

const props = defineProps({
  visible: Boolean,
  data: Object
});

const emits = defineEmits(['update:visible', 'done']);
// 弹框加载
const loading = ref(false);
// 是否是编辑状态
const isUpdate = ref(false);
// 表单数据
const form = ref({});
// ref
const typeFormRef = ref(null);

onMounted(async() => {
  if (props.data) {
    isUpdate.value = true;
    getDetail();
  } else {
    form.value.fldSort = await getBusinessMaxSort('DEVOPS_BUSINESS_CATEGORY');
    isUpdate.value = false;
  }
});

// 获取详情
const getDetail = () => {
  BusinessCategoryApi.detail({ businessCategoryId: props.data.businessCategoryId }).then(res => {
    form.value = Object.assign({}, res);
  });
};

// 更改弹框状态
const updateVisible = value => {
  emits('update:visible', value);
};

// 点击保存
const save = async () => {
  typeFormRef.value.$refs.formRef.validate().then(async valid => {
    if (valid) {
      // 修改加载框为正在加载
      loading.value = true;

      let result = null;

      // 执行编辑或修改
      if (isUpdate.value) {
        result = BusinessCategoryApi.edit(form.value);
      } else {
        result = BusinessCategoryApi.add(form.value);
      }
      result
        .then(async result => {
          // 移除加载框
          loading.value = false;

          // 提示添加成功
          message.success(result.message);
          // 关闭弹框，通过控制visible的值，传递给父组件
          updateVisible(false);

          // 触发父组件done事件
          emits('done');
        })
        .catch(() => {
          loading.value = false;
        });
    }
  });
};
</script>

<style></style>